     /**
     * \brief FFP Example : Echo input to job log
   *
   * \author Mihael Schmidt
   * \date   02.01.2011
   */

     H dftactgrp(*no) actgrp(*caller)
     
     D main            PR                  extpgm('FFPEX01')
     D main            PI

      /include 'rng/input_provider_h.rpgle'
      /include 'rng/streamfile_input_provider_h.rpgle'
      /include 'ffp/parser_h.rpgle'
      /include 'ffp/line_processor_h.rpgle'
      /include 'ffp/echo_line_processor_h.rpgle'
      
      
     D parser          S               *
     D lineProcessor   S               *
     D inputProvider   S               *
      
     D lineFormatChars...
     D                 S            100A
     D inputPath       S           1000A
   /free
       inputPath = '/home/iusr0001/src/ffp/example/echo-input.txt' + x'00';
       
       // create new parser instance 
       parser = ffp_create();

       //
       // configure parser
       // 
       lineFormatChars = '@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@' + x'00';
       ffp_addLineFormatFromImage(parser : 'Variable line Format' :
                                  %addr(lineFormatChars));
                                  
       lineProcessor = ffp_processor_echo_create(parser);
       ffp_addLineProcessor(parser : lineProcessor);
       
       inputProvider = rng_input_stmf_create(%addr(inputPath));
       ffp_setInputProvider(parser : inputProvider);
       
       // do the actual parsing
       ffp_parse(parser);
       
       // clean up
       ffp_finalize(parser);
       
       *inlr = *on;
       return;
   /end-free 
	