     /**
     * \brief FFP Example : Grouped data example
   *
   * \author Mihael Schmidt
   * \date   02.01.2011
   */

     H dftactgrp(*no) actgrp(*caller)
     
     D main            PR                  extpgm('FFPEX03')
     D main            PI

      /include 'rng/input_provider_h.rpgle'
      /include 'rng/streamfile_input_provider_h.rpgle'
      /include 'ffp/parser_h.rpgle'
      /include 'ffp/line_processor_h.rpgle'
      /include 'ffp/grouping_line_processor_h.rpgle'
      /include 'ffp/joblog_logger_h.rpgle'
      
      
     D parser          S               *
     D lineProcessor   S               *
     D inputProvider   S               *
      
     D lineFormatChars...
     D                 S            100A
     D inputPath       S           1000A
   /free
       inputPath = '/home/iusr0001/src/ffp/example/group-input.txt' + x'00';
       
       // create new parser instance
       parser = ffp_create();

       //
       // configure parser
       // 
       lineFormatChars = '100####' + x'00';
       ffp_addLineFormatFromImage(parser : 'id' : %addr(lineFormatChars));
       
       lineFormatChars = '110@@@@@@@@@@' + x'00';
       ffp_addLineFormatFromImage(parser : 'date' : %addr(lineFormatChars));
       
       lineFormatChars = '120######' + x'00';
       ffp_addLineFormatFromImage(parser : 'store' : %addr(lineFormatChars));
       
       lineFormatChars = '210#############' + x'00';
       ffp_addLineFormatFromImage(parser : 'item' : %addr(lineFormatChars));
       
       lineFormatChars = '220#######' + x'00';
       ffp_addLineFormatFromImage(parser : 'quantity' : %addr(lineFormatChars));
       
       lineFormatChars = '999' + x'00';
       ffp_addConstantLineFormat(parser : 'end' : %addr(lineFormatChars));
       
       ffp_setLogger(parser : ffp_logger_joblog_create());
       
       // set up line processor
       lineProcessor = ffp_processor_grouping_create(parser);
       ffp_processor_grouping_setStartLineFormat(lineProcessor : 
           ffp_getLineFormat(parser : 'id'));
       ffp_processor_grouping_setEndLineFormat(lineProcessor : 
           ffp_getLineFormat(parser : 'end'));
       ffp_processor_grouping_setExecutor(lineProcessor : 'FFPEX02EX');
       ffp_processor_grouping_setLogger(lineProcessor : ffp_getLogger(parser));
       ffp_addLineProcessor(parser : lineProcessor);
       
       inputProvider = rng_input_stmf_create(%addr(inputPath)); 
       ffp_setInputProvider(parser : inputProvider);
      
       // do the actual parsing 
       ffp_parse(parser);
       
       // cleanup (all resources registered at the parser will also be cleaned up)
       ffp_finalize(parser);
       
       *inlr = *on;
       return;
   /end-free 
    