      /if not defined(FFPARSER_H)
      /define FFPARSER_H

      *-------------------------------------------------------------------------
      *
      * (C) Copyleft 2011 Mihael Schmidt
      *
      * This file is part of Flat File Parser (FFP).
      *
      * FFP is free software: you can redistribute it and/or modify
      * it under the terms of the GNU General Public License as published
      * the Free Software Foundation, either version 3 of the License, or
      * any later version.
      *
      * FFP is distributed in the hope that it will be useful,
      * but WITHOUT ANY WARRANTY; without even the implied warranty of
      * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      * GNU General Public License for more details.
      *
      * You should have received a copy of the GNU General Public License
      * along with FFP.  If not, see <http://www.gnu.org/licenses/>.
      *
      *-------------------------------------------------------------------------


      *---------------------------------------------------------------
      * Flat File Parser : Prototypes
      *---------------------------------------------------------------
     D ffp_create      PR              *   extproc('ffp_create')
      *
     D ffp_parse       PR              N   extproc('ffp_parse')
     D   parser                        *   const
      *
     D ffp_addLineProcessor...
     D                 PR                  extproc('ffp_addLineProcessor')
     D   parser                        *   const
     D   processor                     *   const
      *
     D ffp_addLineFormatFromImage...
     D                 PR              *   extproc('ffp_addLineFormatFromImage')
     D   parser                        *   const
     D   name                       100A   const varying
     D   chars                         *   const
      *
     D ffp_addConstantLineFormat...
     D                 PR              *   extproc('ffp_addConstantLineFormat')
     D   parser                        *   const
     D   name                       100A   const varying
     D   chars                         *   const
      *
     D ffp_finalize    PR                  extproc('ffp_finalize')
     D   parser                        *
      *
     D ffp_setConfigurationProvider...
     D                 PR                  extproc('ffp_setConfiguration-
     D                                     Provider')
     D   parser                        *   const
     D   provider                      *   const
      *
     D ffp_loadConfiguration...
     D                 PR                  extproc('ffp_loadConfiguration')
     D   parser                        *   const
      *
     D ffp_setIgnoreBlankLines...
     D                 PR                  extproc('ffp_setIgnoreBlankLines')
     D   parser                        *   const
     D   value                         N   const
      *
     D ffp_setProcessInvalidLines...
     D                 PR                  extproc('ffp_setProcessInvalidLines')
     D   parser                        *   const
     D   value                         N   const
      *
     D ffp_addLineFormatField...
     D                 PR                  extproc('ffp_addLineFormatField')
     D   lineFormatPtr...
     D                                 *   const
     D   fieldLength                 10I 0 const
      *
     D ffp_setFieldLengthType...
     D                 PR                  extproc('ffp_setFieldLengthType')
     D   parser                        *   const
     D   type                        10I 0 const
      *
     D ffp_getLogicalLineNumber...
     D                 PR            10I 0 extproc('ffp_getLogicalLineNumber')
     D   parserPtr                     *   const
      *
     D ffp_getPhysicalLineNumber...
     D                 PR            10I 0 extproc('ffp_getPhysicalLineNumber')
     D   parserPtr                     *   const
      *
     D ffp_setInputProvider...
     D                 PR                  extproc('ffp_setInputProvider')
     D   parser                        *   const
     D   provider                      *   const
      *
     D ffp_addValidator...
     D                 PR                  extproc('ffp_addValidator')
     D   pLineFormat                   *   const
     D   field                       10I 0 const
     D   validator                     *   const
      *
     D ffp_getLineFormat...
     D                 PR              *   extproc('ffp_getLineFormat')
     D   parser                        *   const
     D   name                       100A   const varying
      *
     D ffp_setLogger...
     D                 PR                  extproc('ffp_setLogger')
     D   parser                        *   const
     D   logger                        *   const
      *
     D ffp_getLogger...
     D                 PR              *   extproc('ffp_getLogger')
     D   parser                        *   const
      *
     D ffp_setSerializer...
     D                 PR                  extproc('ffp_setSerializer')
     D   parser                        *   const
     D   serializer                    *   const
      *
     D ffp_getSerializer...
     D                 PR              *   extproc('ffp_getSerializer')
     D   parser                        *   const
      *
     D ffp_getLineFormats...
     D                 PR              *   extproc('ffp_getLineFormats')
     D   parser                        *   const
      *
     D ffp_getLineProcessors...
     D                 PR              *   extproc('ffp_getLineProcessors')
     D   parser                        *   const


      *-------------------------------------------------------------------------
      * Data structures
      *-------------------------------------------------------------------------
     D ffp_lineFormat...
     D                 DS                  qualified based(nullPointer)
     D   id                          10I 0
     D   name                       100A   varying
     D   formatcode                    *
     D   formatLength                10I 0
     D   assertProcPtr...
     D                                 *   procptr
     D   validators                    *   dim(99)
     D   validatorField...
     D                               10I 0 dim(99)
     D   validatorCount...
     D                               10I 0
     D   fields                            likeds(ffp_field) dim(99)
     D   fieldCount                  10I 0
      *
     D ffp_field       DS                  qualified based(nullPointer)
     D   start                       10I 0
     D   length                      10I 0


      *-------------------------------------------------------------------------
      * Constants
      *-------------------------------------------------------------------------
     D DOCUMENT_START  C                   1
     D DOCUMENT_END    C                   2
     D GROUP_START     C                   4
     D GROUP_END       C                   8
     D LINE            C                   16

     D LINE_FORMAT_EXACT_MATCH...
     D                 C                   1
     D LINE_FORMAT_VALUE_MATCH...
     D                 C                   2

     D FIELD_LENGTH_TYPE_FIXED...
     D                 C                   128
     D FIELD_LENGTH_TYPE_DELIM...
     D                 C                   256

     D NUMERIC_CHAR_IMAGE...
     D                 C                   '#'
     D ALPHA_CHAR_IMAGE...
     D                 C                   '@'

      /endif

